# st

Unnamed repository; edit this file 'description' to name the repository.

| Log | Files | Refs | README | LICENSE

    commit 4d794b3479cc586de7796d9b060b2eb469a6500d
    parent 44d8c319a9fe51b011ba6a44779659aec45023a7
    Author: Aurélien Aptel <aurelien.aptel@gmail.com>
    Date:   Sun, 21 Jun 2009 19:37:12 +0200

    updated "key" to a lookup table.

    Diffstat:
    Mconfig.h | 21++++++++++-----------
    Mst.c | 20+++-----------------

    2 files changed, 13 insertions(+), 28 deletions(-)
    diff --git a/config.h b/config.h
    @@ -24,16 +24,15 @@ static char* colorname[] = {
     #define DefaultCS 1
     #define BellCol   DefaultFG

    -
     /* special keys */
    -static Key key[] = {
    -	{ XK_Delete, "\033[3~" },
    -	{ XK_Home,   "\033[1~" },
    -	{ XK_End,    "\033[4~" },
    -	{ XK_Prior,  "\033[5~" },
    -	{ XK_Next,   "\033[6~" },
    -	{ XK_Left,   "\033[D" },
    -	{ XK_Right,  "\033[C" },
    -	{ XK_Up,     "\033[A" },
    -	{ XK_Down,   "\033[B" },
    +static char* key[] = {
    +	[XK_Delete] = "\033[3~",
    +	[XK_Home]   = "\033[1~",
    +	[XK_End]    = "\033[4~",
    +	[XK_Prior]  = "\033[5~",
    +	[XK_Next]   = "\033[6~",
    +	[XK_Left]   = "\033[D",
    +	[XK_Right]  = "\033[C",
    +	[XK_Up]     = "\033[A",
    +	[XK_Down]   = "\033[B",
     };
    diff --git a/st.c b/st.c
    @@ -40,12 +40,9 @@ enum { CRset=1, CRupdate=2 };
     enum { TMwrap=1, TMinsert=2 };
     enum { SCupdate, SCredraw };

    -typedef int Color;
    +#include "config.h"

    -typedef struct {
    -	KeySym k;
    -	char s[ESCSIZ];
    -} Key;
    +typedef int Color;

     typedef struct {
     	char c;     /* character code  */
    @@ -98,8 +95,6 @@ typedef struct {
     	int cw; /* char width  */
     } XWindow;

    -#include "config.h"
    -
     /* Drawing Context */
     typedef struct {
     	unsigned long col[LEN(colorname)];
    @@ -997,15 +992,6 @@ draw(int redraw_all) {
     	xcursor(CSdraw);
     }

    -char*
    -kmap(KeySym k) {
    -	int i;
    -	for(i = 0; i < LEN(key); i++)
    -		if(key[i].k == k)
    -			return (char*)key[i].s;
    -	return NULL;
    -}
    -
     void
     kpress(XKeyEvent *e) {
     	KeySym ksym;
    @@ -1018,7 +1004,7 @@ kpress(XKeyEvent *e) {
     	meta  = e->state & Mod1Mask;
     	shift = e->state & ShiftMask;
     	len = XLookupString(e, buf, sizeof(buf), &ksym, NULL);
    -	if(skmap = kmap(ksym))
    +	if(skmap = key[ksym])
     		ttywrite(skmap, strlen(skmap));
     	else if(len > 0) {
     		buf[sizeof(buf)-1] = '\0';